%% EKG BIOFEEDBACK - vsledky 
% skript slou pro monost optovnho naten zznam EKG signlu pro
% poteby zjitn namench hodnot A zobrazen grafickch vstup

clc         
clear all   
close all   

%% parametry
% nsledujc parametry mono upravit dle poteby
fvz = 200;      % vzorkovac frekvence signlu
opakovani=30;   % poet opakovn (poet natanch soubor)
num_prah=1.7;   % nastaven nsoben pro prh detekce QRS (pro fvz=200Hz 1.7, pro fvz=500Hz 2.6)
delka_1zaznamu=10; % dlka jednoho zznamu [s]
num_krok=6;     % krok pro vpoet prmrnch RR interval a stanoven...
                %...odchylky pro vykreslen kuliky (min 2, max dle potu RR interval v jednom zznamu)

% dal parametry doporueno nemnit
posunEKG=fvz*delka_1zaznamu; % posun pro uloen celho signlu EKG (v zvislosti na dlce snmanch st EKG)
% pomocn promnn pro ukldn vsledk z celho signlu
EKG=[];                 % signl EKG
QRS_cele=[];            % detekovan QRS
RR_cele=[];             % RR intervaly
RRkrok_cele=[];         % prumer RR interval pro stanoven krok
odchylkaRR_cele=[];     % odchylka RR interval (vzorky)
odchylkaRRCas_cele=[];  % odchylka RR interval (as)
RRhist_cele=[];         % histogram RR interval
procenta_cele=[];       % procentuln odchylka RR interval
SDNN_cele=[];
RMSSD_cele=[];
TFmin_cele=[];          % tepov frekvence (tep/min)
TFsec_cele=[];          % tepov frekvence (tep/s)
for e=1:opakovani       % nattn jednotlivch soubor
    disp(['Zznam .: ', num2str(e)])
    disp(['-'])
    acq2mat     % peveden uloench soubor z formtu .acq do formtu .mat
                % pozn. ve sloce je nutn mt skript load_acq.m
    if e>100
        xx=['load UNTI0' int2str(e-1) '.mat'];
        eval(xx)
    elseif e>10
        xx=['load UNTI00' int2str(e-1) '.mat'];
        eval(xx)   
    else
        xx=['load UNTI000' int2str(e-1) '.mat'];
        eval(xx);
    end
x=acq.data(:,1)';   % data EKG

zaznam_ekg{e}=x;    % cel zznam EKG
if e==1
EKG(1:posunEKG)=cell2mat(zaznam_ekg(e)); % pro prvn opakovn
else
EKG(((e-1)*posunEKG)+1:e*posunEKG)=cell2mat(zaznam_ekg(e)); % pro dal opakovn
end

%% IMPULSN CHARAKTERISTIKA - vpoet
pasma = 16;
vstup_sig = [zeros(1,fvz/2) 1 zeros(1,fvz/2)];  % jednotkov impuls
imp_char = cwt(vstup_sig,pasma,'mexh');         % "vydolovn" impulsn charakteristiky
 
%% TRANSFORMACE
% prodlouen signlu na zatku a konci 
vstup_sig = x(1,:);    
zp = (length(imp_char)-1)/2;
zacatek(1:ceil(zp)) = vstup_sig(1);     % opakovn prvni hodnoty EKG signlu 
konec(1:ceil(zp)) = vstup_sig(end);     % opakovn posledn hodnoty EKG signlu
vstup_sig = [zacatek vstup_sig konec];  % upraven EKG signl

% vpoet CWT s pomoc konvoluce
konvoluce1 = conv(vstup_sig,imp_char);
% prava zpodn a prodlouench st 
konvoluce = konvoluce1(ceil(zp)+1:end-fix(zp));
konvoluce = konvoluce(ceil(zp)+1:end-ceil(zp));
vystup_sig(1,:) =  konvoluce;           % vsledn vstupn signl

% Zznam celho transformovanho signlu EKG
zaznam_ekgtrans{e}=vystup_sig;          
if e==1
EKG_trans(1:posunEKG)=cell2mat(zaznam_ekgtrans(e)); % pro prvn opakovn
else 
EKG_trans(((e-1)*posunEKG)+1:e*posunEKG)=cell2mat(zaznam_ekgtrans(e)); % pro dal opakovn
end
EKG_spect=EKG_trans; % pro vykresleni spektra (nutn pedevm pro skript v GUI)

%% DETEKCE QRS
prah = num_prah*std(vystup_sig(1,:)); 
pom = [];
for i = 2: length(vystup_sig)-1
    if      abs(vystup_sig(1,i))>= abs(vystup_sig(1,i-1)) && abs(vystup_sig(1,i))>= abs(vystup_sig(1,i+1)) && abs(vystup_sig(1,i))>= prah 
             pom(end+1) = i; 
             QRS{e}=pom; % ukldn poloh detekovanch R vln
    end
end
% zznam detekovanch QRS komplex z celho signlu EKG
QRS_prevod=cell2mat(QRS(e));
delka_QRS(e)=length(QRS_prevod); 
delka_cele=length(QRS_cele);
if e==1
    QRS_cele(e:delka_QRS(e))=QRS_prevod; % pro prvn opakovn
else
    QRS_cele(delka_cele+1:delka_cele+delka_QRS(e))=QRS_prevod+(e-1)*posunEKG; % pro dal opakovn
end
% zobrazen svod signlu + QRS z jednotlivch opakovn
% h2=figure (2);
% subplot(2,1,1)
% plot(vystup_sig)
% hold on
% stem (QRS{e},x(1,QRS{e}),'r')
% title('Zobrazen svodu signlu s detekc R vln')
% xlabel('k [-]')
% ylabel('U [mV]')
% hold off
% % zobrazen transformovanch svod signlu + QRS z jednotlivch opakovn
% subplot (2,1,2)
% plot(vystup_sig)
% hold on
% stem (QRS{e},vystup_sig(1,QRS{e}),'r')
% title ('Zobrazen transformovanch svod signl s detekc R vln')
% xlabel('k [-]')
% ylabel('U [mV]')
% hold off

%% VYKRESLEN RR INTERVAL 
R=cell2mat(QRS(e));         % polohy detekovanch R vln - upraveno do dku
RR=zeros(1,length(R)-1);
for r=2:length(R)
    RR(r-1)=R(r)-R(r-1);    % velikost RR intervalu
end
% zznam RR interval z celho signlu EKG
zaznam_RR{e}=RR;
RR_prevod=cell2mat(zaznam_RR(e));
delka_RR(e)=length(RR_prevod); 
delka_celeRR=length(RR_cele);
if e==1
    RR_cele(e:delka_RR(e))=RR_prevod; % pro prvn opakovn
else
    RR_cele(delka_celeRR+1:delka_celeRR+delka_RR(e))=RR_prevod; % pro dal opakovn    
end

%% HISTOGRAM RR INTERVAL
RR2=zeros(1,length(R)-1);
for ri=1:length(RR)
    if RR(ri)<=400 && RR(ri)>=100 % omezen pro minimalizaci chybov detekce QRS komplexu
        RR2(ri)=RR(ri);
    end
end
% zznam RR interval (s omezenm velikosti) z celho signlu EKG
zaznam_RRhist{e}=RR2(RR2>0);
RRhist_prevod=[];
RRhist_prevod=cell2mat(zaznam_RRhist(e));
delka_RRhist(e)=length(RRhist_prevod); 
delka_celeRRhist=length(RRhist_cele);
if e==1
    RRhist_cele(e:delka_RRhist(e))=RRhist_prevod; % pro prvn opakovn
else
    RRhist_cele(delka_celeRRhist+1:delka_celeRRhist+delka_RRhist(e))=RRhist_prevod; % pro dal opakovn
end
% maximumRR=max(RRhist_cele);
% minimumRR=min(RRhist_cele);
if isempty(RRhist_prevod) || length(RRhist_prevod)==1
    disp(['Chybov detekce QRS komplex, zznam EKG z hodnocen vynechn.'])
    disp(['-----------------------------------------------------------------'])
else    
%% PRMR RR INTERVAL, SDNN, RMSSD Z JEDNOHO ZZNAMU EKG
prumer=(sum(RRhist_prevod))/length(RRhist_prevod); % stedn hodnota [poet vzork]
prumerCas=prumer/fvz; % stedn hodnota [s] 
% vpoet SDNN
for rri=1:length(RRhist_prevod)
    umocneni1(rri)=(RRhist_prevod(rri)-prumer)^2;
end
SDNN=(sqrt((sum(umocneni1))/length(RRhist_prevod)))/fvz; % [s]
% zznam hodnot SDNN z celho signlu EKG 
zaznam_SDNN{e}=SDNN;
SDNN_prevod=cell2mat(zaznam_SDNN(e));
delka_SDNN(e)=length(SDNN_prevod); 
delka_celeSDNN=length(SDNN_cele);
if e==1
    SDNN_cele(e:delka_SDNN(e))=SDNN_prevod; % pro prvn opakovn
else
    SDNN_cele(delka_celeSDNN+1:delka_celeSDNN+delka_SDNN(e))=SDNN_prevod; % pro dal opakovn    
end
SDNN=[];

% vpoet RMSSD
for rri=2:length(RRhist_prevod)
    umocneni2(rri-1)=(RRhist_prevod(rri)-RRhist_prevod(rri-1))^2;
end
RMSSD=(sqrt((sum(umocneni2))/(length(RRhist_prevod)-1)))/fvz; % [s]
% zznam hodnot RMSSD z celho signlu EKG 
zaznam_RMSSD{e}=RMSSD;
RMSSD_prevod=cell2mat(zaznam_RMSSD(e));
delka_RMSSD(e)=length(RMSSD_prevod); 
delka_celeRMSSD=length(RMSSD_cele);
if e==1
    RMSSD_cele(e:delka_RMSSD(e))=RMSSD_prevod; % pro prvn opakovn
else
    RMSSD_cele(delka_celeRMSSD+1:delka_celeRMSSD+delka_RMSSD(e))=RMSSD_prevod; % pro dal opakovn    
end
RMSSD=[];

disp(['Prmr RR interval je ', num2str(prumer), ' vzork, ',...
    num2str(prumerCas), 'sec.'])
disp(['Hodnota SDNN pro dan sek EKG signlu je: ', num2str(SDNN),' s.'])
disp(['Hodnota RMSSD pro dan sek EKG signlu je: ', num2str(RMSSD),' s.'])

%% TRVN JEDNOHO ZZNAMU EKG SIGNLU A TEPOV FREKVENCE
trvani_ekg_sec=length(vystup_sig)/fvz;  %transformovan sig 
trvani_ekg_min=trvani_ekg_sec/60; 
disp (['EKG signl je dlouh: ', num2str(trvani_ekg_sec),' s, ',...
    num2str(trvani_ekg_min),' min.'])
TFsec=1/(prumer/fvz);                   % prmrn TF [tep/s] 
TFmin=60/(prumer/fvz);                  % prmrn TF [tep/min] 
disp(['Tepov frekvence je: ', num2str(TFsec),' der/s, ',...
    num2str(TFmin), ' der/min.'])
disp(['-----------------------------------------------------------------'])
% zznam tepov frekvence z celho signlu EKG 
zaznam_TFmin{e}=TFmin;
TFmin_prevod=cell2mat(zaznam_TFmin(e));
delka_TFmin(e)=length(TFmin_prevod); 
delka_celeTFmin=length(TFmin_cele);
if e==1
    TFmin_cele(e:delka_TFmin(e))=TFmin_prevod; % pro prvn opakovn
else
    TFmin_cele(delka_celeTFmin+1:delka_celeTFmin+delka_TFmin(e))=TFmin_prevod; % pro dal opakovn
end
zaznam_TFsec{e}=TFsec;
TFsec_prevod=cell2mat(zaznam_TFsec(e));
delka_TFsec(e)=length(TFsec_prevod); 
delka_celeTFsec=length(TFsec_cele);
if e==1
    TFsec_cele(e:delka_TFsec(e))=TFsec_prevod; % pro prvn opakovn
else
    TFsec_cele(delka_celeTFsec+1:delka_celeTFsec+delka_TFsec(e))=TFsec_prevod; % pro dal opakovn
end

%% PRMRN VELIKOST RR INTERVAL PRO URIT KROK A JEJICH ODCHYLKA
%% (ODCHYLKA TEPOV FREKVENCE)
RRkrok=[];
odchylkaRR=[];
odchylkaRRCas=[];
krok=num_krok+1;
while isempty(odchylkaRR)&& krok>=2
krok=krok-1;  % poet interval RR, ze kterch probh hodnocen odchylky
if krok>1
delka=length(RRhist_prevod);
m=1;
for n = 1:floor(delka/krok)
    RRkrok(n)=(sum(RRhist_prevod(m:m+krok-1)))/krok; % prmr z danho potu (krok) RR interval
    m=m+krok;
    RRkrokCas(n)=RRkrok(n)/fvz; 
    disp(['Prmrn velikost vzork RR interval pro krok ', num2str(krok), ' je: ', num2str(RRkrok(n)), ' vzork, ', num2str(RRkrokCas(n)), ' s.']) 
end

if length(RRkrok)<=1
disp(['Prmrn velikost vzork RR interval pro krok ',num2str(krok),' tohoto zznamu nebyla hodnocena.'])
RRkrok=[];
RRkrokCas=[];
end 

% Odchylka
odchylkaRR=zeros(1,length(RRkrok)-1);
for o=2:length(RRkrok)
    odchylkaRR(o-1)=RRkrok(o)-RRkrok(o-1); % odchylka [poet vzork]
    odchylkaRRCas(o-1)=odchylkaRR(o-1)/fvz; % odchylka [s] 
    disp (['Odchylka jednotlivch prmrnch interval v tomto kroku in: ', num2str(odchylkaRR(o-1)), ' vzork, ', num2str(odchylkaRRCas(o-1)), ' s.'])
end

% Prmr RR interval pro stanoven krok dle potu vzork z celho signlu EKG
zaznam_RRkrok{e}=RRkrok;
RRkrok_prevod=cell2mat(zaznam_RRkrok(e));
delka_RRkrok(e)=length(RRkrok_prevod); 
delka_celeRRkrok=length(RRkrok_cele);
if e==1
    RRkrok_cele(e:delka_RRkrok(e))=RRkrok_prevod; % pro prvn opakovn
else
    RRkrok_cele(delka_celeRRkrok+1:delka_celeRRkrok+delka_RRkrok(e))=RRkrok_prevod; % pro dal opakovn   
end
% OdchylkaRR dle potu vzork z celho signlu EKG
zaznam_odchylkaRR{e}=odchylkaRR;
odchylkaRR_prevod=cell2mat(zaznam_odchylkaRR(e));
delka_odchylkaRR(e)=length(odchylkaRR_prevod); 
delka_celeodchylkaRR=length(odchylkaRR_cele);
if e==1
    odchylkaRR_cele(e:delka_odchylkaRR(e))=odchylkaRR_prevod; % pro prvn opakovn
else
    odchylkaRR_cele(delka_celeodchylkaRR+1:delka_celeodchylkaRR+delka_odchylkaRR(e))=odchylkaRR_prevod; % pro dal opakovn   
end
% Odchylka RR dle asu z celho signlu EKG 
zaznam_odchylkaRRCas{e}=odchylkaRRCas;
odchylkaRRCas_prevod=cell2mat(zaznam_odchylkaRRCas(e));
delka_odchylkaRRCas(e)=length(odchylkaRRCas_prevod); 
delka_celeodchylkaRRCas=length(odchylkaRRCas_cele);
if e==1
    odchylkaRRCas_cele(e:delka_odchylkaRRCas(e))=odchylkaRRCas_prevod; % pro prvn opakovn
else
    odchylkaRRCas_cele(delka_celeodchylkaRRCas+1:delka_celeodchylkaRRCas+delka_odchylkaRRCas(e))=odchylkaRRCas_prevod; % pro dal opakovn   
end

% stanoven procentuln odchylky (odpovd procentuln odchylce tepov
% frekvence)
procenta=[];
for p=1:length(odchylkaRRCas)
    procenta(p)=(abs(odchylkaRRCas(p))/prumerCas)*100;
    disp(['Procentuln odchylka jednotlivch RR interval je: ', num2str(procenta(p)), '.'])
end
% zznam procentuln odchylky RR interval z celho signlu EKG
zaznam_procenta{e}=procenta;
procenta_prevod=cell2mat(zaznam_procenta(e));
delka_procenta(e)=length(procenta_prevod); 
delka_celeprocenta=length(procenta_cele);
if e==1
    procenta_cele(e:delka_procenta(e))=procenta_prevod; % pro prvn opakovn
else
    procenta_cele(delka_celeprocenta+1:delka_celeprocenta+delka_procenta(e))=procenta_prevod; % pro dal opakovn   
end

%% sputn funkce Pruzeni - simulace pohybu kuliky
% Pruzeni % skript nutno upravit, nastaven pro poteby zobrazen v GUI

else
    disp(['Chybov detekce QRS komplex, zznam EKG z hodnocen vynechn.'])
end
end
end
end

%% VSLEDN ZOBRAZEN SNMANHO EKG SIGNLU
%% EKG signl snman a EKG signl transformovan
h2=figure(2); 
subplot (2,1,1)
plot(EKG)
title ('Zobrazen snmanho EKG signlu')
xlabel('k [-]')
ylabel('U [mV]')
subplot(2,1,2)
plot(EKG_trans)
title('Zobrazen snmanho EKG signlu po transformaci')
xlabel('k [-]')
ylabel('U [mV]')

%% Detekce QRS
% zobrazen svod signlu + QRS
h3=figure(3);
subplot(2,1,1)
plot(EKG_trans)
hold on
stem (QRS_cele,EKG(1,QRS_cele),'r')
title('Zobrazen svodu signlu s detekc R vln')
xlabel('k [-]')
ylabel('U [mV]')
hold off
% zobrazen transformovanch svod signlu + QRS
subplot (2,1,2)
plot(EKG_trans)
hold on
stem (QRS_cele,EKG_trans(1,QRS_cele),'r')
title ('Zobrazen transformovanch svod signl s detekc R vln')
xlabel('k [-]')
ylabel('U [mV]')
hold off

%% Spektrum EKG
%pracuji s transformovanch signlem
% delka_sig=length(EKG_trans);
% spect_sig=zeros(1,delka_sig);
% spect=fft(EKG_trans); %spetkrum
% spect_sig=abs(spect); %absolutn hodnota spektra
% EKG_trans=real(ifft(spect)); %inverzn fft
delkaFFT=4096;
delka_signalu_EKG=length(EKG_spect);
okno=hamming(delka_signalu_EKG)';
spect_sig=abs(fft(EKG_spect.*okno,delkaFFT));
spect_osa=[0:delkaFFT/2]*fvz/delkaFFT;
EKG_trans=real(ifft(spect_sig)); %inverzn fft

h4=figure(4);
subplot(2,1,1);
% plot(spect_sig(2:length(spect_sig)));
% title('Spectrum EKG')
% xlabel('k [-]')
% ylabel('|S(f)| [mV]')
plot(spect_osa,spect_sig(1:length(spect_osa)));
axis([0 50 0 max(spect_sig)+1])
title('Spectrum EKG')
xlabel('f [Hz]')
ylabel('|S(f)| [mV]')

%% Vkonov spektrum EKG
%pracuji s transformovanm signlem
% vyk_spect_sig=zeros(1,delka_sig);
% vyk_spect_sig=abs(fft(EKG_trans)).^2;
vyk_spect_sig=zeros(1,delka_signalu_EKG);
vyk_spect_sig=abs(fft(EKG_spect,delkaFFT)).^2;

subplot(2,1,2)
% plot(vyk_spect_sig(2:length(vyk_spect_sig)))
% title ('Vkonov spektrum EKG')
% xlabel('k [-]')
% ylabel('Ps [mV]')
plot(spect_osa,vyk_spect_sig(1:length(spect_osa)));
title('Vkonov spectrum EKG')
axis([0 50 0 max(vyk_spect_sig)+1])
xlabel('f [Hz]')
ylabel('Ps [mV]')

%% RR intervaly
h5=figure(5);
stem (RR_cele)
title('Sekvence hodnot interval RR')
xlabel('Poad RR intervalu [-]')
ylabel('Dlka RR intervalu (k[-])')

%% Odchylka RR interval v ase pro urit krok
h6=figure(6);
stem(odchylkaRRCas_cele)
title ('Odchylka RR interval pro stanoven krok')
xlabel ('Poad odchylky [-]')
ylabel ('Velikost odchylky [s]')

%% Histogram RR interval
h7=figure(7);
hist(RRhist_cele,500);
title('Histogram RR interval')
xlabel('Dlka RR intervalu (k[-])')
ylabel('Poet RR interval [-]')
% axis([0  300  0  40])

%% Poincarho mapy
h8=figure(8);
hold on
for j = 3:length(QRS_cele)
    k = QRS_cele(j) - QRS_cele(j-1);
    l = QRS_cele(j-1) - QRS_cele(j-2);
    if k < 0.8*prumer
        disp (['Pravdpodobnost chybn detekce (vzorek slo: ', num2str(QRS_cele(j)),') z dvodu blzkosti detekovanch pk.'])
    end
    if k > 1.2*prumer
        disp (['Pravdpodobnost chybn detekce (vzorek slo: ', num2str(QRS_cele(j)),') z dvodu velk vzdlenosti detekovanch pk.'])      
    end
    plot (k,l,'o')
end
hold off
title ('Poincarho mapy')
xlabel ('Dlka RR(r) intervalu (k[-])')
ylabel ('Dlka RR(r-1) intervalu (k[-])')
% axis([0 2*maximumRR 0 2*maximumRR]);
disp(['-----------------------------------------------------------------'])

%% ZVREN VPOTY
prumer_celkovy=(sum(prumer))/length(prumer);        % prmr RR interval z celho men (poet vzork)
prumer_celkovy_cas=(sum(prumerCas))/length(prumer); % prmr RR interval z celho men (v ase)
disp(['Prmr RR interval z celho zznamu EKG je: ', num2str(prumer_celkovy),...
    ' vzork, ',num2str(prumer_celkovy_cas), ' s.'])
prumerna_TFmin=(sum(TFmin))/length(TFmin);          % prmrn tepov frekvence (min) z celho men
prumerna_TFsec=(sum(TFsec))/length(TFsec);          % prmrn tepov frekvence (sec) z celho men
disp(['Prmrn tepov frekvence z celho zznamu EKG je: ', num2str(prumerna_TFmin),...
    ' der/min, ',num2str(prumerna_TFsec), ' der/s.'])
prumerna_procodchylka=(sum(procenta_cele))/length(procenta_cele); %prmrn procentuln odchylka RR interval
disp(['Prmrn odchylka RR interval z celho zznamu EKG je: ', num2str(prumerna_procodchylka),...
    ' %.'])
% hodnota SDNN z celho zznamu EKG
for c=1:length(RRhist_cele)
    umocneni3(c)=(RRhist_cele(c)-prumer_celkovy)^2;
end
SDNN_celkove=(sqrt((sum(umocneni3))/length(RRhist_cele)))/fvz;  % SDNN z celho zznamu EKG [s]
% SDNN2=sum(SDNN)/length(SDNN) % prmrn SDNN z celho men [s]
disp(['SDNN z celho zznamu EKG je: ', num2str(SDNN_celkove),' s.'])

% hodnota RMSSD z celho zznamu EKG
for d=2:length(RRhist_cele)
    umocneni4(d-1)=(RRhist_cele(d)-RRhist_cele(d-1))^2;
end
RMSSD_celkove=(sqrt((sum(umocneni4))/(length(RRhist_cele)-1)))/fvz; % RMSSD z celho zznamu EKG [s]
% RMSSD2=sum(RMSSD)/length(RMSSD) % prmrn RMSSD z celho men [s]
disp(['RMSSD z celho zznamu EKG je: ', num2str(RMSSD_celkove),' s.'])
disp(['-----------------------------------------------------------------'])
disp(['Konec.'])

RMSSD_cele=RMSSD_cele';
RR_cele=RR_cele';
RRhist_cele=RRhist_cele';
RRkrok_cele=RRkrok_cele';
SDNN_cele=SDNN_cele';
TFmin_cele=TFmin_cele';
TFsec_cele=TFsec_cele';
odchylkaRR_cele=odchylkaRR_cele';
odchylkaRRCas_cele=odchylkaRRCas_cele';
procenta_cele=procenta_cele';
